' --------------------------------------------------------------------------------------
'
' MolPatBlock.VB                                                  Ulrich Mller 20.09.02
'                                                                 PCS1700   VB.NET Final
' Moltke Patience : Logik, Legen und Anzeigen, Version mit BlockDrag
' Basis PotiPat.DLL und QCard32.DLL
'
' Ablage  : obere Reihe mit den Pltzen 0 - 7
' Auslage : mittlerer Bereich mit 10 Leitern (0 - 9 ) mit max. maxCard Karten
' Keller  : linke untere Reihe, nicht anlegbare Karten
' Talon   : rechte untere Ecke, noch nicht gezogene Karten
'
' --------------------------------------------------------------------------------------

Imports PotiPat

Public Class MolException
  Inherits Exception
  Public Sub New(ByVal message$)
    MyBase.New(message)
  End Sub
End Class

' MolPatience -----------------------------------------------------------------------
'             Spielspezifische Methoden fr die Patience Moltke
' -----------------------------------------------------------------------------------
Public Class MolPatience
  Inherits PotiPatience

  Public Event GameWon(ByVal Pati As MolPatience)

  ' --------------------------- Private Felder ---------------------------------------
  
  Private Talon As KartenPaket   ' --- KartenPaket
  Private Keller As LiFoStack    ' --- Karten im Keller
  Private Ablage As Ablage48     ' --- Ablage
  Private AusLage As AuslageV    ' --- Karten der Auslage

  Private SrcCard As Card, SrcPos As New CardPos()
  Private CardList(15), anzCard As Integer

  Private lblAblage, lblTalon As Label

  ' New ------------------------------------------------------------------------------
  '     Konstruktor : Aufsetzen QCard32Pool, Bestimmen der Spielbereichskoordinaten
  '                   Instanzieren der Spielbereiche
  ' ----------------------------------------------------------------------------------
  Sub New(ByVal Canvas As Form, ByVal lblAblage As Label, ByVal lblTalon As Label)
    MyBase.New(Canvas)

    Dim XNull, XTalon, YNull, YAblage, YKeller As Integer

    Me.lblAblage = lblAblage
    Me.lblTalon = lblTalon

    ' --- Spielbereichs Koordinaten ------------------------
    XNull = 16
    YAblage = 16
    YNull = YAblage + qc.CardHeight + 32
    XTalon = XNull + qc.CardWidthS * 9
    YKeller = YNull + 15 * qc.Offset + qc.CardHeight + 32

    ' --- Spielbereichs Objekte -----
    Talon = New KartenPaket(qc, 2, XTalon, YKeller)
    Keller = New LiFoStack(qc, 55, XNull, YKeller, XTalon - XNull)
    Ablage = New Ablage48(qc, 8, qc.CardWidthS, XNull, YAblage, 2)
    AusLage = New AuslageV(qc, 10, qc.CardWidthS, XNull, YNull, YKeller - YNull)

    ' --- Anzeige-Labels Ausrichten ----
    lblAblage.Top = Ablage.Top + Ablage.Range.Height / 3
    lblAblage.Left = Ablage.Left + Ablage.Range.Width / 2 - lblAblage.Width / 2
    lblTalon.Top = Keller.Top + Keller.Range.Height + 3
    lblTalon.Left = Talon.Left + Talon.Range.Width / 2 - lblTalon.Width / 2

  End Sub

  '
  ' --------- Private Methoden ----------------------------------------------------
  '

  ' SpielAuslegen -------------------------------------------------------------------
  '             Auslegen der Moltke-Patience
  ' -------------------------------------------------------------------------------
  Private Sub SpielAuslegen(ByVal Talon As KartenPaket)
    Dim i, j As Integer
    Dim SrcCard As Card

    AusLage.Clear()
    For i = 0 To 4
      For j = 0 To 9
        SrcCard = Talon.RemoveCard()
        If i > 0 Then
          ' --- Disabled = True wenn keine Leiter
          If Not AusLage.IsDescendingChanging(SrcCard, j) Then
            AusLage.TopMostCard(j).Disabled = True
          End If
        End If
        AusLage.AddCard(SrcCard, j)
      Next j
    Next i
  End Sub

  ' AblegenFreieKarten --------------------------------------------------------------
  '                    Prfen und Ablegen von freien Karten
  '                    TopMostCards der Auslage und des Kellers. 
  '                    Ende : in der Suchschleife keine anlegbare Karte gefunden
  ' ---------------------------------------------------------------------------------
  Private Sub AblegenFreieKarten()
    Dim Found As Boolean
    Dim col As Integer, b As Boolean
    Dim SrcCard As Card
    Do
      Found = False
      For col = 0 To 9                        ' --- Auslage
        SrcCard = AusLage.TopMostCard(col)
        If Not IsNothing(SrcCard) Then        ' --- Karte auf Auslage-Spalte
          If SrcCard.Value <= MinValue(SrcCard) Then
            b = CardToAblage(SrcCard)         ' --- die nchstkleineren Karten der 
            If b Then Found = True '                anderen Farbe sind grer
          End If
        End If
      Next col
      SrcCard = Keller.TopMostCard()          ' --- Keller
      If Not IsNothing(SrcCard) Then
        If SrcCard.Value <= MinValue(SrcCard) Then
          b = CardToAblage(SrcCard)
          If b Then Found = True
        End If
      End If
    Loop While Found
  End Sub

  ' MinValue ---------------------------------------------------------------------
  '          Finden des kleinsten Kartenwertes einer Farbe in der Ablage
  ' ------------------------------------------------------------------------------
  Private Function MinValue(ByVal SrcCard As Card) As Integer
    Dim minV = 12
    Dim col, UG, OG As Integer
    Dim inx() As Integer = {0, 1, 4, 5, 2, 3, 6, 7}
    Dim DestCard As Card
    If SrcCard.Color = ColorCode.Rot Then
      UG = 0
      OG = 3
    Else
      UG = 4
      OG = 7
    End If
    For col = UG To OG    ' --- Schleife ber Karten der entgegengesetzen Farbe
      DestCard = Ablage.TopMostCard(inx(col))
      If Not IsNothing(DestCard) Then
        minV = IIf(DestCard.Value < minV, DestCard.Value, minV)
      Else
        minV = 2
      End If
    Next col
    Return minV
  End Function

  ' CardToAblage ------------------------------------------------------------------
  '              Prfen  & Ablegen Karte von Auslage oder Keller nach Ablage
  ' -------------------------------------------------------------------------------
  Private Function CardToAblage(ByVal SrcCard As Card) As Boolean
    Dim DestCol = Choose(SrcCard.Suit, 0, 3, 2, 1)
    If Not Ablage.IsAscendingSuit(SrcCard, DestCol) Then
      DestCol += 4
      If Not Ablage.IsAscendingSuit(SrcCard, DestCol) Then Return False
    End If
    If SrcCard.Area = AreaCode.Auslage Then AusLage.RemoveCard(SrcCard.PosC) _
    Else Keller.RemoveCard()
    Ablage.AddCard(SrcCard, DestCol)
    Return True
  End Function

  ' FindDestPos ------------------------------------------------------------------------
  '             Bestimmen der angegebenen Position (in Pixelkoordinaten)
  ' ------------------------------------------------------------------------------------
  Private Function FindDestPos(ByVal X%, ByVal Y%) As CardPos
    Dim DestPos As New CardPos()

    DestPos.CardNr = 0
    If Ablage.Range.Contains(X, Y) Then
      DestPos.Area = AreaCode.Ablage
      DestPos.PosC = Ablage.XToCol(X)
    ElseIf AusLage.Range.Contains(X, Y) Then
      DestPos.Area = AreaCode.Auslage
      DestPos.PosC = AusLage.XToCol(X)
    ElseIf Keller.Range.Contains(X, Y) Then
      DestPos.Area = AreaCode.Keller
      DestPos.PosC = 0
    Else
      DestPos.Area = AreaCode.none
      DestPos.PosC = 0
    End If
    DestPos.PosR = -1                            ' --- Keine Zeilenangabe
    Return DestPos
  End Function

  '
  ' ------ Public Methoden -------------------------------------------------------
  '

  ' SpielStarten -------------------------------------------------------------------
  '              Starten eines neuen Spieles : Initwerte, Mischen, Auslegen 
  ' --------------------------------------------------------------------------------
  Public Overrides Sub SpielStarten(ByVal SpielNr%)

    Canvas.CreateGraphics.Clear(Color.Green)
    Talon.Shuffle(SpielNr)
    Ablage.Clear()
    SpielAuslegen(Talon)
    Keller.Clear()
    lblAblage.Visible = True
    lblTalon.Visible = True
  End Sub

  ' Refresh -------------------------------------------------------------------------
  '         Wiederherstellen des aktuellen Kartenbildes 
  ' ---------------------------------------------------------------------------------
  Public Overrides Sub Refresh()
    Ablage.Paint()
    AusLage.Paint()
    Keller.Paint()
    Talon.Paint()
  End Sub

  ' StartZiehen ---------------------------------------------------------------------
  '             Starten des Ziehens einer Karte wenn Maus ber Karte, sonst merken
  '             der Mausposition
  ' ---------------------------------------------------------------------------------
  Public Overrides Sub StartZiehen(ByVal X%, ByVal Y%)
    Dim SrcNr% = qc.InitDrag(X, Y)   ' --- Starten Drag, wenn Maus auf Karte
    Dim i%, j%
    If SrcNr = 0 Then
      SrcPos.CardNr = 0
      SrcPos.PicX = X
      SrcPos.PicY = Y
      qc.AbortDrag()                 ' --- Keine Karte, Merken Mauspositione fr 
      DragMode = DragCode.None       '     DoppelClick, Abbruch Drag

    Else                             ' --- Auf Karte
      If qc.GetCardBlocked(SrcNr) Then
        DragMode = DragCode.Block    ' --- Start BlockDrag, wenn nicht oberste Karte
        SrcCard = AusLage.ActualCard(qc.GetUser3(SrcNr), qc.GetUser4(SrcNr))
        j = 0     ' --- Bestimmen der umzulegenden Karten
        For i = SrcCard.PosR To AusLage.CardCount(SrcCard.PosC) - 1
          CardList(j) = AusLage.ActualCard(SrcCard.PosC, i).CardNr
          j += 1
        Next i
        anzCard = AusLage.CardCount(SrcCard.PosC) - SrcCard.PosR
      Else
        DragMode = DragCode.One
        Select Case qc.GetUser2(SrcNr)  ' --- Bestimmen der Karten-Area
          Case AreaCode.Ablage          ' --- Lesen der obersten Karte der jeweiligen Area
            SrcCard = Ablage.TopMostCard(qc.GetUser3(SrcNr))
          Case AreaCode.Auslage
            SrcCard = AusLage.TopMostCard(qc.GetUser3(SrcNr))
          Case AreaCode.Keller
            SrcCard = Keller.TopMostCard
          Case AreaCode.Talon
            SrcCard = Talon.TopMostCard
        End Select
      End If
    End If
  End Sub

  ' WeiterZiehen ------------------------------------------------------------------
  '              Fortsetzen des Ziehens
  ' -------------------------------------------------------------------------------
  Public Overrides Sub WeiterZiehen(ByVal X%, ByVal Y%)
    Select Case DragMode
      Case DragCode.Block
        qc.BlockDrag(CardList(0), anzCard, X, Y)
      Case DragCode.One
        qc.DoDrag(X, Y)
      Case Else
    End Select
  End Sub

  ' EndeZiehen ---------------------------------------------------------------------
  '            Beenden des Ziehens, Bestimmen der Zielposition, Ablegen der Karte
  '            bzw. Rcklegen einer unpassenden Karte
  ' --------------------------------------------------------------------------------
  Public Overrides Sub EndeZiehen(ByVal X%, ByVal Y%)

    Dim DestPos As CardPos
    Select Case DragMode

      ' ------------------ SingleDrag ----------------------

    Case DragCode.One
        qc.EndDrag(X, Y)
        DestPos = FindDestPos(X, Y)             ' --- Zielposition
        Select Case DestPos.Area                ' --- Prfen des Platzes der Area
          Case AreaCode.Ablage                  '     Ablage
            If Ablage.IsAscendingSuit(SrcCard, DestPos.PosC) Then
              If SrcCard.Area = AreaCode.Auslage Then
                SrcCard = AusLage.RemoveCard(SrcCard.PosC)
              Else
                SrcCard = Keller.RemoveCard()
              End If
              Ablage.AddCard(SrcCard, DestPos.PosC)
            Else
              qc.ReturnDrag(SrcCard.CardNr, SrcCard.PicX, SrcCard.PicY)
            End If
          Case AreaCode.Auslage                 ' --- Auslage
            If AusLage.IsDescendingChanging(SrcCard, DestPos.PosC, ValueCode.Alle) Then
              If SrcCard.Area = AreaCode.Auslage Then
                SrcCard = AusLage.RemoveCard(SrcCard.PosC)
              Else
                SrcCard = Keller.RemoveCard()
              End If
              AusLage.AddCard(SrcCard, DestPos.PosC)
            Else
              qc.ReturnDrag(SrcCard.CardNr, SrcCard.PicX, SrcCard.PicY)
            End If
          Case Else
            qc.ReturnDrag(SrcCard.CardNr, SrcCard.PicX, SrcCard.PicY)
        End Select

        ' ---------------------- BlockDrag innerhalb der Auslage --------------------

      Case DragCode.Block
        qc.EndBlockDrag(CardList(0), anzCard, X, Y)
        DestPos = FindDestPos(X, Y)
        If DestPos.Area = AreaCode.Auslage And _
            AusLage.IsDescendingChanging(SrcCard, DestPos.PosC, ValueCode.Alle) And _
            AusLage.IsEnoughSpace(anzCard, DestPos.PosC) Then
          AusLage.AddRange(AusLage.RemoveRange(SrcCard.PosR, SrcCard.PosC), DestPos.PosC)
        Else
          qc.ReturnBlockDrag(CardList(0), anzCard, SrcCard.PicX, SrcCard.PicY)
        End If

        ' --------------------- Else ------------------------------------------------

      Case Else
        Return
    End Select

    ' --- Beenden Drag -------------------------------------------------

    DragMode = DragCode.None
    AblegenFreieKarten()
    lblAblage.Text = 104 - Ablage.CardCount
    lblTalon.Text = Talon.CardCount
    If Ablage.CardCount = 104 Then RaiseEvent GameWon(Me)

  End Sub

  ' KarteAblegen -------------------------------------------------------------------
  '              Prfen und angegebene Karte ablegen (nach z.B. DoppelClick)
  ' --------------------------------------------------------------------------------
  Public Overrides Sub KarteAblegen()
    Dim Karte As Card
    If DragMode <> DragCode.None Then
      qc.AbortDrag()
      DragMode = DragCode.None

      Select Case SrcCard.Area
        Case AreaCode.Auslage, AreaCode.Keller
          If Not SrcCard.Blocked Then CardToAblage(SrcCard)
        Case AreaCode.Talon
          Keller.AddCard(Talon.RemoveCard())
        Case Else
      End Select
    End If
    AblegenFreieKarten()
    lblAblage.Text = 104 - Ablage.CardCount
    lblTalon.Text = Talon.CardCount
    If Ablage.CardCount = 104 Then RaiseEvent GameWon(Me)
  End Sub

End Class
